<script setup lang="ts">
import { useUtillityStore } from '@/stores/utillity'
import { computed, onMounted, ref } from 'vue'
import { useDate } from 'vuetify'
import type { VForm } from 'vuetify/components'

const utillityStore = useUtillityStore()
const utillities = computed(() => utillityStore.utillities.value)
// const UtillityStore = useUtillityStore;

onMounted(() => {
  utillityStore.getUtillities()
})

const adapter = useDate()
const date: Date = new Date('2024-02-27')
</script>

<template>
  <div>
    <v-sheet>
      <v-container fluid>
        <v-toolbar flat>
          <v-toolbar-title>Utillity Bill</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="utillityStore.dialog.value" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn size="40px" v-bind="props" prepend-icon="mdi-plus-thick" class="mr-5"> </v-btn>
            </template>
            <v-card style="background-color: #fff5e8">
              <v-card-title>
                <span class="text-h5">New Utillity</span>
              </v-card-title>
              <v-card-text>
                <v-form v-model="utillityStore.from.value" @submit.prevent="utillityStore.onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-file-input
                          v-model="utillityStore.editedUtillity.value.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 2000000 ||
                                'Image size should be less than 2 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg"
                          placeholder="Pick an picture"
                          prepend-icon="mdi-camera"
                          label="Picture"
                        ></v-file-input>
                      </v-col>
                      <v-col width="auto" cols="12" sm="12" md="6">
                        <v-date-picker
                          width="auto"
                          height="470"
                          style="background-color: #dec6ae"
                        ></v-date-picker>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Type"
                          :items="['Water bill', 'Electric bill', 'Internet bill', 'Phone bill']"
                          v-model="utillityStore.editedUtillity.value.type"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="utillityStore.editedUtillity.value.price"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="utillityStore.editedUtillity.value.detail"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Detail"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-img
                          :src="
                            'http://localhost:3000/images/utillites/' +
                            utillityStore.editedUtillity.value.picture
                          "
                          width="200"
                        ></v-img>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="utillityStore.save()"> Save </v-btn>
                <v-btn variant="text" @click="utillityStore.closeDialog()"> Close </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="utillityStore.dialogDelete.value" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn variant="text" @click="utillityStore.closeDelete">Cancel</v-btn>
                <v-btn variant="text" @click="utillityStore.deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>

        <v-table fixed-header height="530">
          <thead>
            <tr>
              <th>Id</th>
              <th>Picture</th>
              <th>Date</th>
              <th>Type</th>
              <th>Price</th>
              <th>Detail</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in utillities" :key="item.id">
              <td>{{ item.id }}</td>
              <td>
                <v-img
                  :src="'http://localhost:3000/images/utillites/' + item.picture"
                  width="100"
                ></v-img>
              </td>
              <td>{{ item.dateAdded }}</td>
              <td>{{ item.type }}</td>
              <td>{{ item.price }}</td>
              <td>{{ item.detail }}</td>
              <td>
                <v-icon size="small" class="me-2" @click="utillityStore.editItem(item)">
                  mdi-pencil
                </v-icon>
                <v-icon size="small" @click="utillityStore.deleteItem(item)"> mdi-delete </v-icon>
              </td>
            </tr>
          </tbody>

          <template v-if="!utillities.length">
            <v-btn @click="utillityStore.getUtillities"> Reset </v-btn>
          </template>
        </v-table>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
  padding: 8px 16px;
}

.info {
  font-size: 14px;
}
</style>
